local Factions = {}
local RepStandingColor = {["Hated"] 	 = "|cFFCC2224",
						  ["Hostile"] 	 = "|cFFFF221C",
						  ["Unfriendly"] = "|cFFCF6624",
						  ["Neutral"]	 = "|cFFFFDF00",
						  ["Friendly"]	 = "|cFF0aF207",
						  ["Honored"]	 = "|cFF09F25C",
						  ["Revered"]	 = "|cFF03FFAC",
						  ["Exalted"]	 = "|cFF02FEDC",
						  ["Paragon"]	 = "|cFF02FEDC"}
local VenariStanding = {[1] = "Dubious",
						[2] = "Apprehensive",
						[3] = "Tentative",
						[4] = "Ambivalent",
						[5] = "Cordial",
						[6] = "Appreciative",
						[7] = "Paragon"}
local VenariColor = {["Dubious"] 		= "|cFFFFDF00",
				     ["Apprehensive"] 	= "|cFF0aF207",
					 ["Tentative"]		= "|cFF09F25C",
					 ["Ambivalent"] 	= "|cFF03FFAC",
					 ["Cordial"]		= "|cFF02FEDC",
					 ["Appreciative"] 	= "|cFF02FEDC",
					 ["Paragon"]		= "|cFF02FEDC"}
local FriendshipStanding = {[1] = "Stranger",
							[2] = "Acquaintance",
						    [3] = "Buddy",
						    [4] = "Friend",
							[5] = "Good Friend",
							[6] = "Best Friend",
							[7] = "Best Friend"}
local FriendshipColor = {["Stranger"]     = "|cFFFFDF00",
						 ["Acquaintance"] = "|cFF0aF207",
						 ["Buddy"]	  	  = "|cFF09F25C",
						 ["Friend"] 	  = "|cFF03FFAC",
						 ["Good Friend"]  = "|cFF02FEDC",
						 ["Best Friend"]  = "|cFF02FEDC"}
-- local FriendshipColor = {["Stranger"]     = "|cFF7B7B7B",
-- 						 ["Acquaintance"] = "|cFFE7E7E7",
-- 						 ["Buddy"]	  	  = "|cFF1FEA04",
-- 						 ["Friend"] 	  = "|cFF0070DD",
-- 						 ["Good Friend"]  = "|cFFA335EE",
-- 						 ["Best Friend"]  = "|cFFE17305"}
local textColor = "|cFFABD6F4"
local newFactionColor = "|cFF9B8900"

local function loadFactions(start, finish)
	start = start or 1
	finish = finish or GetNumFactions()
	for factionIndex = start, finish do
		-- name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus = GetFactionInfo(index)
		local name, _, _, _, _, _, _, _, isHeader, isCollapsed, _, _, _, factionID = GetFactionInfo(factionIndex)
		Factions[name] = factionID
		if isHeader == true and thenisCollapsed == true then
			ExpandFactionHeader(factionIndex)
			loadFactions(factionIndex, factionIndex+(GetNumFactions()-finish))
			CollapseFactionHeader(factionIndex)
		end
	end
end

local function factionInfo(factionName)
	if factionName == "Guild" then
		local name, _, standingID, bottomValue, topValue, earnedValue = GetGuildFactionInfo()
		return name, bottomValue, topValue, earnedValue, standingID
	end

	if Factions[factionName] == nil then
		loadFactions()
		if Factions[factionName] == nil then 
			-- NOTE: if we get here, something is wrong. Probably found a new faction.
			return "error", nil, nil, nil, nil
		end
	end

	-- name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus = GetFactionInfoByID(factionID)
	local name, description, standingID, bottomValue, topValue, earnedValue, _, _, _, _, _, _, _, factionID, _, _ = GetFactionInfoByID(Factions[factionName])

	-- C_GossipInfo.GetFriendshipReputation(factionID) - returns a table with: 
	-- friendshipFactionID, standing, maxRep, name, text, texture, reaction, reactionThreshold, nextThreshold, reversedColor, overrideColor
	local frienshipFactionTable = C_GossipInfo.GetFriendshipReputation(factionID)
	local isFriend = false
	if frienshipFactionTable["friendshipFactionID"] ~= 0 then
		isFriend = true
		local friendshipRankTable = C_GossipInfo.GetFriendshipReputationRanks(frienshipFactionTable["friendshipFactionID"])
		bottomValue = frienshipFactionTable["reactionThreshold"]
		topValue = frienshipFactionTable["nextThreshold"]
		earnedValue = frienshipFactionTable["standing"]
		standingID = friendshipRankTable["currentLevel"]
		if topValue == nil then
			topValue = bottomValue
		end

		-- DEBUG
		-- print("    factionID:", factionID)
		-- print("    table:", frienshipFactionTable)
		-- print("    friendshipFactionID:", frienshipFactionTable["friendshipFactionID"])
		-- print("    standing:", frienshipFactionTable["standing"])
		-- print("    maxRep:", frienshipFactionTable["maxRep"])
		-- print("    friendshipName:", frienshipFactionTable["name"])
		-- print("    text:", frienshipFactionTable["text"])
		-- print("    texture:", frienshipFactionTable["texture"])
		-- print("    reaction:", frienshipFactionTable["reaction"])
		-- print("    reactionThreshold:", frienshipFactionTable["reactionThreshold"])
		-- print("    nextThreshold:", frienshipFactionTable["nextThreshold"])
		-- print("    reversedColor:", frienshipFactionTable["reversedColor"])
		-- print("    overrideColor:", frienshipFactionTable["overrideColor"])
		-- print("----------------------------")
		-- print("    currentLevel:", friendshipRankTable["currentLevel"])
		-- print("    maxLevel:", friendshipRankTable["maxLevel"])
		-- print("########")
		---end
	end

	-- return name, bottomValue, topValue, earnedValue, standingID, isFriend

	-- #DEBUG:# 
	--      Reputation with Sho increased by 2359. 
	-- ######## 
	--     factionID: 1278 
	--     table: table: 000002216ECF68F0 
	-- LOOP 
	-- nil 
	-- LOOP-END 
	--     friendshipFactionID: 1278 
	--     standing: 2359 
	--     maxRep: 42000 
	--     friendshipName: Sho 
	--     text: Sho considers you a Stranger. Sho likes Lovely Apples and Eternal Blossom Fish. 
	--     texture: 0 
	--     reaction: Stranger 
	--     reactionThreshold: 0 
	--     nextThreshold: 8400 
	--     reversedColor: false 
	--     overrideColor: nil 
	-- ---------------------------- 
	--     currentLevel: 1 
	--     maxLevel: 6 
	-- ######## 
	--     standingID:  4 
	--     topValue:  33600 
	--     earnedValue:  25200 
	--     bottomValue:  25200 
	--     delta:  2359 
	-- ######## 

	-- #DEBUG:# 
    --  Reputation with Sho increased by 1652. 
	-- ######## 
	-- 	factionID: 1278 
	-- 	table: table: 0000022222A89CB0 
	-- LOOP 
	-- nil 
	-- LOOP-END 
	-- 	friendshipFactionID: 1278 
	-- 	standing: 4011 
	-- 	maxRep: 42000 
	-- 	friendshipName: Sho 
	-- 	text: Sho considers you a Stranger. Sho likes Lovely Apples and Eternal Blossom Fish. 
	-- 	texture: 0 
	-- 	reaction: Stranger 
	-- 	reactionThreshold: 0 
	-- 	nextThreshold: 8400 
	-- 	reversedColor: false 
	-- 	overrideColor: nil 
	-- ---------------------------- 
	-- 	currentLevel: 1 
	-- 	maxLevel: 6 
	-- ######## 
	-- 	standingID:  5 
	-- 	topValue:  42000 
	-- 	earnedValue:  33600 
	-- 	bottomValue:  33600 
	-- 	delta:  1652 
	-- ######## 

	return name, bottomValue, topValue, earnedValue, standingID, isFriend
end

local function stringSplit(str)
	local table = {}
	local ix = 0
	for word in string.gmatch(str, "%S+") do
		table[ix] = word
		ix = ix + 1
	end

	return table
end

local function parseMsg(message)
	local words = stringSplit(message)
	local name = ""
	local change = ""
	local delta = 0

	-- Checking if this is a Ve'nari message... (Shadowlands 9.0 patch)
	if words[0] == "Ve'nari" then
		-- format: "Ve'nari judges you more worthy. [### reputation gained.]"
		name = "Ve'nari"
		change = "increased"
		delta = tonumber(string.sub(words[5], 2))
	else 
		-- Message format: "Reputation with {%s} [increased|decreased] by %d."
		name = words[2]
		for ix = 3, #words do
			-- Checking if this message is a combat experience one (BFA 8.2 patch). E.g. "{%s} has gained %d combat experience."
			if words[ix] == "combat" and words[ix+1]  == "experience." then
				name = ""
				for iy = 0, #words do 
					if words[iy] == "has" and words[iy+1] == "gained" then
						delta = tonumber(words[iy+2])
						return false, name, "", delta
					end
					name = name .. " " .. words[iy]
				end
			end
			
			if words[ix] == "increased" or words[ix] == "decreased" then
				change = words[ix]
				delta = tonumber(words[ix+2]:sub(1, -2))
				break
			end
			name = name .. " " .. words[ix]
		end
	end

	return true, name, change, delta
end

local function levelUpMsg(message)
	local valid, name, change, delta = parseMsg(message)
	local changeColor = "|cFF42FF42+"
	if change == "decreased" then
		changeColor = "|cFFFF4242-"
	end

	if not valid then
		return textColor .. name .. " " .. changeColor .. delta ..  textColor .. " combat experience."
	end

	local factionName, bottomValue, topValue, earnedValue, standingID, isFriend = factionInfo(name)
	if factionName == "error" then
		return newFactionColor .. "New Faction! " .. textColor .. name .. " " .. changeColor .. delta
	end

	local factionID = Factions[factionName]
	local currentvalue = 0
	local threshold = 0
	local hasBonusRepGain = false
	local hasRewardPending = false
	if name ~= "Guild" and C_Reputation.IsFactionParagon(factionID) == true then 
		-- currentValue, threshold, rewardQuestID, hasRewardPending
		currentValue, threshold, _, hasRewardPending = C_Reputation.GetFactionParagonInfo(factionID)
		bottomValue = 0
		topValue = threshold
		earnedValue = currentValue
	end

	-- local repStanding = getglobal("FACTION_STANDING_LABEL" .. standingID)
	local repStanding = _G["FACTION_STANDING_LABEL" .. standingID]
	if isFriend then
		repStanding = FriendshipStanding[standingID]
	end

	if name == "Ve'nari" then
		repStanding = VenariStanding[standingID]
	end 

	if repStanding == "Exalted" or repStanding == "Appreciative" or repStanding == "Best Friend" then
		-- This is a paragon reward message.
		-- We need to subtrack from earned value till we are less than the topValue.
		while earnedValue > topValue do
			earnedValue = earnedValue - topValue
		end
	end

	local deltaLeft = topValue-earnedValue
	local repColor = RepStandingColor[repStanding]
	local repNextStanding = _G["FACTION_STANDING_LABEL" .. standingID+1]
	local repNextColor = RepStandingColor[repNextStanding]

	if name == "Ve'nari" then 
		repColor = VenariColor[repStanding]
		repNextStanding = VenariStanding[standingID+1]
		repNextColor = VenariColor[repNextStanding]
	elseif isFriend then
		repColor = FriendshipColor[repStanding]
		repNextStanding = FriendshipStanding[standingID+1]
		repNextColor = FriendshipColor[repNextStanding]
	end

	local perTotal = 100-math.floor((earnedValue-bottomValue)*100/(topValue-bottomValue) + 0.5)
	if perTotal == 100 or perTotal == 0 then
		perTotal = tonumber(string.format("%.2f", 100-math.floor((earnedValue-bottomValue)*100/(topValue-bottomValue) * 100 + 0.5) / 100))
	end
	local perDelta = math.floor(delta * 100 / (topValue-bottomValue) * 10 + 0.5) / 10
	if perDelta == 0 then
		perDelta = tonumber(string.format("%.2f", math.floor(delta * 100 / (topValue-bottomValue) * 100 + 0.5) / 100))
	end

	-- print("    standingID: ", standingID)
	-- print("    topValue: ", topValue)
	-- print("    earnedValue: ", earnedValue)
	-- print("    bottomValue: ", bottomValue)
	-- print("    delta: ", delta)
	-- print("########")

	-- local testString = "#color$factionName#color $delta ($perDelta) - #color$standing #colorwith $delta ($total) left to #color$nextStanding"
	local msg = ""
	if repStanding == "Exalted" or repStanding == "Appreciative" or repStanding == "Best Friend" then
		if name ~= "Guild" and C_Reputation.IsFactionParagon(factionID) then
			-- Message format: "{$factionName} already at exalted. 123(5%) with 234(6%) left to paragon reward.
			if hasRewardPending == true then 
				msg = textColor .. factionName .. " already at " .. repColor .. "Exalted" .. textColor .. ". With " .. repColor .. "Paragon" .. textColor .. " reward already achieved."
			else 
				msg = textColor .. factionName .. " " ..  changeColor .. delta .. " (" .. perDelta .. "%) " .. textColor .. "- " .. repColor .. repStanding .. textColor .. " with " .. deltaLeft .. " (" .. perTotal .. "%) left to " .. repColor .. "Paragon" .. textColor .. " reward."
			end
		else
			msg = textColor .. factionName .. textColor .. " already at " .. repColor .. repStanding .. textColor .. "."
		end
	else
		msg = textColor .. factionName .. " " ..  changeColor .. delta .. " (" .. perDelta .. "%) " .. textColor .. "- " .. repColor .. repStanding .. textColor .. " with " .. deltaLeft .. " (" .. perTotal .. "%) left to " .. repNextColor .. repNextStanding
	end
	return msg
end

local function replaceBlizzard(self, event, message, ...)
	-- print("#DEBUG:#")
	-- print("    ", message)
	-- print("########")
	return false, levelUpMsg(message), ...
end

-- local levelUpEvent = CreateFrame("Frame")
-- levelUpEvent:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
-- levelUpEvent:SetScript("OnEvent", levelUP)
ChatFrame_AddMessageEventFilter("CHAT_MSG_COMBAT_FACTION_CHANGE", replaceBlizzard)
local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_LOGIN")
frame:SetScript("OnEvent", function()
					loadFactions()
				end)


-- /run print((select(4, GetBuildInfo())));
-- 	for k,v in pairs(_G) do
-- 		if string.find(k, "FRIENDSHIP") then
-- 			print( k,v )
-- 		end
-- 	end
-- for debugging:
-- /run zipRepDebugging()

-- SLASH_ZIFREP1 = "/zifrep-debug"
-- local function zipRepDebugging()
-- 	print("#DEBUG:#")
-- 	print("    ", levelUpMsg("Reputation with The Wild Hunt increased by 300."))
-- 	print("    ", levelUpMsg("Reputation with Rajani decreased by 200."))
-- 	print("    ", levelUpMsg("Reputation with Sho increased by 564."))
-- 	print("    ", levelUpMsg("Reputation with Conjurer Margoss increased by 420"))
-- 	print("    ", levelUpMsg("Ve'nari judges you more worthy. [75 reputation gained.]"))
-- 	print("    ", levelUpMsg("Zifre has gained 150 combat experience."))
-- 	print("    ", levelUpMsg("Reputation with NEW-FACTION-TEST increased by 1."))
-- 	print("########")
-- end
-- SlashCmdList["ZIFREP"] = zipRepDebugging
